﻿using SqlSugar;
using System;
using System.ComponentModel.DataAnnotations;
using System.Reflection;
using System.Linq;

namespace Falcon.SugarApi.DatabaseDefinitions
{
    /// <summary>
    /// SqlSugar数据库连接配置
    /// </summary>
    public class SugarConnectionConfig : ConnectionConfig
    {
        /// <summary>
        /// 是否使用log
        /// </summary>
        public bool Log { get; set; }
        /// <summary>
        /// 实例化SugarDb链接配置
        /// </summary>
        public SugarConnectionConfig() {
            this.ConfigureExternalServices ??= new ConfigureExternalServices { };
            this.ConfigureExternalServices.EntityService += (p, c) => {
                var pt = p.PropertyType;
                if (pt.GetCustomAttribute<RequiredAttribute>() != null) {
                    c.IsNullable = false;
                    return;
                }
                if (pt.IsGenericType && pt.GetGenericTypeDefinition() == typeof(Nullable<>)) {
                    c.IsNullable = true;
                    return;
                }
                //var sc = pt.GetCustomAttribute<SugarColumn>();
                //if (sc != null) {
                //    c.IsNullable = sc.IsNullable;
                //}
                var isNullableTypes = new Type[] { typeof(string) };
                if (isNullableTypes.Contains(pt)) {
                    c.IsNullable = true;
                }
                else {
                    c.IsNullable = false;
                }
                //if (pt == typeof(string) && pt.GetCustomAttribute<RequiredAttribute>() == null) {
                //    c.IsNullable = true;
                //}
            };
        }
    }
}
